"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:llvm_s' }"

"{ NameSpace: Smalltalk }"

SharedPool subclass:#LLVMDIFlags
	instanceVariableNames:''
	classVariableNames:'LLVMDIFlagZero LLVMDIFlagPrivate LLVMDIFlagProtected
		LLVMDIFlagPublic LLVMDIFlagFwdDecl LLVMDIFlagAppleBlock
		LLVMDIFlagBlockByrefStruct LLVMDIFlagVirtual LLVMDIFlagArtificial
		LLVMDIFlagExplicit LLVMDIFlagPrototyped
		LLVMDIFlagObjcClassComplete LLVMDIFlagObjectPointer
		LLVMDIFlagVector LLVMDIFlagStaticMember LLVMDIFlagLValueReference
		LLVMDIFlagRValueReference LLVMDIFlagExternalTypeRef
		LLVMDIFlagSingleInheritance LLVMDIFlagMultipleInheritance
		LLVMDIFlagVirtualInheritance LLVMDIFlagIntroducedVirtual
		LLVMDIFlagBitField LLVMDIFlagNoReturn LLVMDIFlagAccessibility'
	poolDictionaries:''
	category:'LLVM-S-Core-Constants'
!

!LLVMDIFlags class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!LLVMDIFlags class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    LLVMDIFlagZero := 0.
    LLVMDIFlagPrivate := 1.
    LLVMDIFlagProtected := 2.
    LLVMDIFlagPublic := 3.
    LLVMDIFlagFwdDecl := (1 << 2).
    LLVMDIFlagAppleBlock := (1 << 3).
    LLVMDIFlagBlockByrefStruct := (1 << 4).
    LLVMDIFlagVirtual := (1 << 5).
    LLVMDIFlagArtificial := (1 << 6).
    LLVMDIFlagExplicit := (1 << 7).
    LLVMDIFlagPrototyped := (1 << 8).
    LLVMDIFlagObjcClassComplete := (1 << 9).
    LLVMDIFlagObjectPointer := (1 << 10).
    LLVMDIFlagVector := (1 << 11).
    LLVMDIFlagStaticMember := (1 << 12).
    LLVMDIFlagLValueReference := (1 << 13).
    LLVMDIFlagRValueReference := (1 << 14).
    LLVMDIFlagExternalTypeRef := (1 << 15).
    LLVMDIFlagSingleInheritance := (1 << 16).
    LLVMDIFlagMultipleInheritance := (2 << 16).
    LLVMDIFlagVirtualInheritance := (3 << 16).
    LLVMDIFlagIntroducedVirtual := (1 << 18).
    LLVMDIFlagBitField := (1 << 19).
    LLVMDIFlagNoReturn := (1 << 20).
    LLVMDIFlagAccessibility := LLVMDIFlagPrivate | LLVMDIFlagProtected | LLVMDIFlagPublic

    "Modified: / 15-09-2016 / 22:12:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


LLVMDIFlags initialize!
